;=======================================================================
proc format_text
;-----------------------------------------------------------------------
    cmp eax,IDL_M0
    jae .m
    lea ecx,[eax - IDL_B]
    cmp eax,IDL_LANG
    je  .l
    cmp eax,IDL_URL
    je  .u
    stdcall set_tags,[hTran],[tags_tab + ecx*4]
    ret
.m:
    sub eax,IDL_M0
    stdcall format_para,[hTran],[m_tab + eax*4]
    ret
.l:
    ret
.u:
    ret
;-----------------------------------------------------------------------
endp
;=======================================================================
;
;=======================================================================
proc set_tags hEdit,_tag
;-----------------------------------------------------------------------
    local a: dd ?
    local b: dd ?
;-----------------------------------------------------------------------
    push edi
    push esi
    push ebx
;-----------------------------------------------------------------------
    lea ecx,[a]
    lea edx,[b]
    invoke SendMessage,[hEdit],EM_GETSEL,ecx,edx
    mov eax,[b]
    sub eax,[a]
    je  @F
    jns .ready
    neg eax
    jmp .ready
@@:    
;-----------------------------------------------------------------------
    invoke SendMessage,[hEdit],EM_GETHANDLE,0,0
    or  eax,eax
    je  .done
    invoke LocalLock,eax
    or  eax,eax
    mov ebx,eax
    je  .done
    shl [b],1
    mov esi,ebx
    std
    cmp [b],0
    je  .text_begin
    add esi,[b]
    sub esi,2
@@:
    cmp esi,ebx
    je  .text_begin
    lodsw
    mov ecx,delims_count        
    mov edi,delims + delims_count * 2 - 2
    repne scasw
    jne @B
    add esi,4
.text_begin:
    sub esi,ebx
    shr esi,1
    mov [a],esi
    cld
    mov esi,ebx
    add esi,[b]
@@:
    lodsw
    mov ecx,delims_count        
    mov edi,delims
    repne scasw
    jne @B
    sub esi,2
    sub esi,ebx
    shr esi,1
    invoke LocalUnlock,ebx
    invoke SendMessage,[hEdit],EM_SETSEL,[a],esi
    mov eax,esi
    sub eax,[a] 
;-----------------------------------------------------------------------
.ready:    
    add eax,256
    add eax,eax
    invoke LocalAlloc,0,eax
    or  eax,eax
    mov ebx,eax
    mov edi,eax            
    jz  .done_free
    UCSAdd [_tag]
    stdcall EditGetSel,[hEdit],edi
    lea edi,[edi + edx*2]
    UCSAdd
    invoke SendMessage,[hEdit],EM_REPLACESEL,TRUE,ebx
;-----------------------------------------------------------------------
.done_free:
    invoke LocalFree,ebx
;-----------------------------------------------------------------------
.done:    
    pop ebx
    pop esi
    pop edi
    ret
;-----------------------------------------------------------------------
endp
;=======================================================================
;
;=======================================================================
proc format_para hEdit,_tag
;-----------------------------------------------------------------------
    local a: dd ?
    local b: dd ?
;-----------------------------------------------------------------------
    push edi
    push esi
    push ebx
;-----------------------------------------------------------------------
    lea eax,[b]
    lea ecx,[a]
    invoke SendMessage,[hEdit],EM_GETSEL,ecx,eax
    mov esi,[a]
    mov edi,[b]
    cmp esi,edi
    jle @F
    xchg esi,edi
@@:    
    invoke SendMessage,[hEdit],EM_LINEFROMCHAR,esi,0
    mov [a],eax
    invoke SendMessage,[hEdit],EM_LINEFROMCHAR,edi,0
    mov [b],eax
    invoke SendMessage,[hEdit],WM_GETTEXTLENGTH,0,0
    add eax,eax
    add eax,4
    invoke LocalAlloc,0,eax
    or  eax,eax
    mov ebx,eax
    jz  .done
    mov esi,[b]
    sub esi,[a]
    inc esi
    mov [b],esi
;-----------------------------------------------------------------------
.next:
    mov esi,[a]
    inc esi
    invoke SendMessage,[hEdit],EM_LINEINDEX,esi,0
    push eax
    invoke SendMessage,[hEdit],EM_LINEINDEX,[a],0
    push eax
    invoke SendMessage,[hEdit],EM_SETSEL
    mov [a],esi
    mov edi,ebx
    UCSAdd [_tag]
    stdcall EditGetSel,[hEdit],edi
    push esi
    mov ecx,edx
    mov esi,edi
@@:
    lodsw
    or  ax,ax
    je  @F
    cmp ax,9
    je  .ltrim
    cmp ax,32
    jne @F
.ltrim:
    dec ecx
    jmp @B
@@:
    sub esi,2
    cmp ecx,edx
    je  @F
    rep movsw
    jmp .ready
@@:
    lea edi,[edi + edx*2]
.ready:
    sub edi,2
    cmp word [edi],13
    je  .ready
    cmp word [edi],10
    je  .ready
    pop esi
    add edi,2
    UCSAdd
    invoke SendMessage,[hEdit],EM_REPLACESEL,TRUE,ebx
    dec [b]
    jnz .next    
    invoke LocalFree,ebx       
;-----------------------------------------------------------------------
.done:    
    pop ebx
    pop esi
    pop edi
    ret
;-----------------------------------------------------------------------
endp
;=======================================================================
